package koropeta.core;
import java.awt.*;
import java.awt.geom.*;
import java.awt.datatransfer.*;
import java.io.*;

public final class Collision implements Cloneable, Serializable {
    private static final DataFlavor data_flavor =
        new DataFlavor(Collision[].class, "koropeta.core.Collision[]");
    
    private Rectangle rect;
    private String id;

    public Collision(Rectangle rect, String id) {
        this.rect = new Rectangle(rect);
        this.id = id;
    }

    public final int x() {
        return rect.x;
    }
    public final int x(int x) {
        rect.x = x;
        return x;
    }
    
    public final int y() {
        return rect.y;
    }
    public final int y(int y) {
        rect.y = y;
        return y;
    }
    
    public final int width() {
        return rect.width;
    }
    public final int width(int width) {
        if (width > 0) {
            rect.width = width;
        }
        return rect.width;
    }
    
    public final int height() {
        return rect.height;
    }
    public final int height(int height) {
        if (height > 0) {
            rect.height = height;
        }
        return rect.height;
    }

    public final Rectangle rect() {
        return new Rectangle(rect);
    }
    public final Rectangle rect(Rectangle r) {
        rect = new Rectangle(r);
        return rect();
    }

    public final String id() {
        return id;
    }
    public final String id(String id) {
        this.id = id;
        return id;
    }

    public synchronized Object clone() {
        return new Collision(rect, id);
    }

    public static final DataFlavor data_flavor() {
        return data_flavor;
    }
}
