package koropeta.core;
import java.awt.*;
import java.awt.datatransfer.*;
import java.io.*;

public final class CollisionSelection implements Transferable, ClipboardOwner {
    
    private static final DataFlavor[] flavors = new DataFlavor[] {
        Collision.data_flavor(),
    };

    Collision[] collisions;

    public CollisionSelection(Collision coll) {
        init(new Collision[] { coll });
    }

    public CollisionSelection(Collision[] coll) {
        init(coll);
    }

    private void init(Collision[] coll) {
        synchronized (coll) {
            collisions = new Collision[coll.length];
            System.arraycopy(coll, 0, collisions, 0, coll.length);
        }
    }

    public DataFlavor[] getTransferDataFlavors() {
        return flavors;
    }

    public boolean isDataFlavorSupported(DataFlavor flavor) {
        for (int i = 0; i < flavors.length; i++) {
            if (flavors[i].equals(flavor)) {
                return true;
            }
        }
        return false;
    }

    public Object getTransferData(DataFlavor flavor)
        throws UnsupportedFlavorException {

        if (flavors[0].equals(flavor)) {
            return collisions;
        }
        else {
            throw new UnsupportedFlavorException(flavor);
        }
    }

    public void lostOwnership(Clipboard clipboard, Transferable contents) {
        // do nothing
    }
}
