package koropeta.core;
import java.text.*;
import java.util.*;

public class GT {
    private ResourceBundle bundle;
    private static GT gt;

    public static void init(Locale locale) {
	gt = new GT(locale);
    }

    public final static String tr(String msg) {
	return gt.translate(msg, null);
    }

    public final static String tr(String msg, int arg) {
	return gt.translate(msg, new Object[] {new Integer(arg)});
    }

    public final static String tr(String msg, Object arg) {
	return gt.translate(msg, new Object[] {arg});
    }

    public final static String tr(String msg, Object[] args) {
	return gt.translate(msg, args);
    }

    private GT(Locale locale) {
	try {
	    bundle = ResourceBundle.getBundle("koropeta.l10n.koropeta", locale);
	}
	catch (MissingResourceException e) {
	    System.err.println(e.toString());
	}
    }

    private final String translate(String msg, Object[] args) {
	String pattern;
	if (bundle != null) {
	    try {
		pattern = bundle.getString(msg);
	    }
	    catch (MissingResourceException e) {
		pattern = msg;
	    }
	}
	else {
	    pattern = msg;
	}

	if (args != null) {
	    return MessageFormat.format(pattern, args);
	}
	else {
	    return pattern;
	}
    }
}