package koropeta.core;
import java.util.*;

public class NumericComparator implements Comparator {
    public int compare(Object o1, Object o2) {
	/*
	  <PHO> ソートの件、風呂の中で良い方法を思い付きました
	  <PHO> 文字と数字の混合された文字列s1, s2を取る比較関数を考える。(s1 = "10_____1", s2 = "2_____2")
	  <PHO> s1の先頭の文字を見て、それが文字であればそのまま、数字であれば数字でなくなるまで次の文字を読み続ける。
	  <PHO> その結果をs1'とする (s1' = "10")。s2からも同様にしてs2'を得る。(s2' = "2")
	  <PHO> s1'とs2'が等しくない場合、s1'とs2'を比較して終了。特にs1'とs2'が共に数字である場合は、数値比較を行う (s1' > s2')。
	  <PHO> s1'とs2'が等しい場合、前回読んだ文字の次から再び読み始める。
	  <PHO> 読むべき文字が無くなったら、先に無くなった方を「より小さい」とする
	*/
	if (o1.equals(o2)) {
	    return 0;
	}
	
	String s1 = (String)o1;
	String s2 = (String)o2;
	int s1_len = s1.length(), s2_len = s2.length();
	int s1_pos = 0, s2_pos = 0;
	char c1, c2; // 讀んだ文字 (數値なら先頭の數字)
	long n1 = 0, n2 = 0; // 讀んだ數値
	boolean b1, b2; // 讀んだのが數値ならtrue

	while (true) {
	    if (s1_pos == s1_len) {
		return -1;
	    }
	    else if (s2_pos == s2_len) {
		return 1;
	    }

	    c1 = s1.charAt(s1_pos);
	    s1_pos++;
	    if (c1 >= '0' && c1 <= '9') {
		b1 = true;
		n1 = c1 - '0';

		while (true) {
		    if (s1_pos == s1_len) {
			// もう讀める文字が無い
			break;
		    }
			
		    char c = s1.charAt(s1_pos);
		    if (c >= '0' && c <= '9') {
			n1 = n1 * 10 + (c - '0');
			s1_pos++;
		    }
		    else {
			// 讀んだものが數字でない
			break;
		    }
		}
	    }
	    else {
		b1 = false;
	    }

	    c2 = s2.charAt(s2_pos);
	    s2_pos++;
	    if (c2 >= '0' && c2 <= '9') {
		b2 = true;
		n2 = c2 - '0';

		while (true) {
		    if (s2_pos == s2_len) {
			// もう讀める文字が無い
			break;
		    }
			
		    char c = s2.charAt(s2_pos);
		    if (c >= '0' && c <= '9') {
			n2 = n2 * 10 + (c - '0');
			s2_pos++;
		    }
		    else {
			// 讀んだものが數字でない
			break;
		    }
		}
	    }
	    else {
		b2 = false;
	    }

	    if (b1 && b2) {
		if (n1 < n2) {
		    return -1;
		}
		else if (n1 > n2) {
		    return 1;
		}
	    }
	    else {
		if (c1 < c2) {
		    return -1;
		}
		else if (c1 > c2) {
		    return 1;
		}
	    }
	}
    }
}