package koropeta.core.animation;
import koropeta.*;
import java.util.*;

public class AnimPattern implements Cloneable {
    String method;
    int surface_id;
    int interval; // ミリ秒
    int offset_x;
    int offset_y;

    int start_id; // start用
    Vector alternative_ids; // alternativestart用
    int insert_id; // insert用

    boolean is_dirty;

    public Object clone() {
	AnimPattern pat = new AnimPattern();
	pat.method = method;
	pat.surface_id = surface_id;
	pat.interval = interval;
	pat.offset_x = offset_x;
	pat.offset_y = offset_y;
	pat.start_id = start_id;
	if (alternative_ids != null) {
	    pat.alternative_ids = (Vector)alternative_ids.clone();
	}
	pat.insert_id = insert_id;
	pat.is_dirty = is_dirty;
	return pat;
    }

    public final String method() {
	return method;
    }
    public final String method(String m) {
	method = m;
	return m;
    }

    public final int surface_id() {
	return surface_id;
    }
    public final int surface_id(int id) {
	surface_id = id;
	return id;
    }

    // ミリ秒
    public final int interval() {
	return interval;
    }
    public final int interval(int itv) {
	interval = itv;
	return itv;
    }

    public final int offset_x() {
	return offset_x;
    }
    public final int offset_x(int off) {
	offset_x = off;
	return off;
    }

    public final int offset_y() {
	return offset_y;
    }
    public final int offset_y(int off) {
	offset_y = off;
	return off;
    }

    public final boolean dirty() {
	return is_dirty;
    }
    public final boolean dirty(boolean b) {
	is_dirty = b;
	return b;
    }

    public final int start_id() {
	return start_id;
    }
    public final int start_id(int id) {
	start_id = id;
	return id;
    }

    public final Vector alternative_ids() {
	// nullかも知れない點に注意
	return alternative_ids;
    }
    public final Vector alternative_ids(Vector ids) {
	alternative_ids = ids;
	return ids;
    }

    public final int insert_id() {
	return insert_id;
    }
    public final int insert_id(int id) {
	insert_id = id;
	return id;
    }

    public boolean has_interval() {
	return
	    method.equals("overlay") ||
	    method.equals("overlayfast") ||
	    method.equals("base") ||
	    method.equals("move") ||
	    method.equals("reduce");
    }
    
    public boolean does_make_group_layer() {
	return
	    method.equals("overlay") ||
	    method.equals("overlayfast") ||
	    method.equals("reduce") ||
	    method.equals("bind") ||
	    method.equals("add");
    }

    public boolean does_sleep() {
	return
	    method.equals("overlay") ||
	    method.equals("overlayfast") ||
	    method.equals("base") ||
	    method.equals("move") ||
	    method.equals("reduce");
    }
}