package koropeta.gui;
import javax.swing.*;
import java.awt.*;

public class TrackingScrollablePanel
    extends JPanel
    implements Scrollable {

    boolean track_width = true;
    boolean track_height = false;

    int horizontal_unit = 10;
    int vertical_unit = 10;

    int horizontal_block_adjustment = -20;
    int vertical_block_adjustment = -20;

    public TrackingScrollablePanel() {
	super();
    }

    public TrackingScrollablePanel(boolean isDoubleBuffered) {
	super(isDoubleBuffered);
    }

    public TrackingScrollablePanel(LayoutManager layout) {
	super(layout);
    }

    public TrackingScrollablePanel(LayoutManager layout, boolean isDoubleBuffered) {
	super(layout, isDoubleBuffered);
    }

    public void track_width(boolean val) {
	track_width = val;
    }

    public void track_height(boolean val) {
	track_height = val;
    }

    public Dimension getPreferredScrollableViewportSize() {
	return getPreferredSize();
    }

    public int getScrollableUnitIncrement(
	Rectangle visibleRect,
	int orientation,
	int direction) {

	if (orientation == SwingConstants.VERTICAL) {
	    return vertical_unit;
	}
	else {
	    return horizontal_unit;
	}
    }

    public int getScrollableBlockIncrement(
	Rectangle visibleRect,
	int orientation,
	int direction) {

	if (orientation == SwingConstants.VERTICAL) {
	    return getParent().getHeight() + vertical_block_adjustment;
	}
	else {
	    return getParent().getWidth() + horizontal_block_adjustment;
	}
    }

    public boolean getScrollableTracksViewportWidth() {
	return track_width;
    }

    public boolean getScrollableTracksViewportHeight() {
	return track_height;
    }
}