package koropeta.gui.dnd;
import koropeta.gui.dnd.*;
import java.awt.datatransfer.*;
import java.io.*;
import javax.swing.*;

public class TableSelectionTransferable implements Transferable {
    static DataFlavor table_selection_data_flavor;
    static {
	try {
	    table_selection_data_flavor = 
		new DataFlavor(DataFlavor.javaJVMLocalObjectMimeType +
			       ";class="+TableSelectionData.class.getName());
	}
	catch (ClassNotFoundException e) {
	    throw new RuntimeException(e);
	}
    }

    TableSelectionData tsd;

    public static DataFlavor flavor() {
	return table_selection_data_flavor;
    }

    public TableSelectionTransferable(JTable table) {
	tsd = new TableSelectionData(table);
    }

    public DataFlavor[] getTransferDataFlavors() {
	return new DataFlavor[] { table_selection_data_flavor };
    }

    public boolean isDataFlavorSupported(DataFlavor flavor) {
	return flavor.equals(table_selection_data_flavor);
    }

    public Object getTransferData(DataFlavor flavor)
	throws UnsupportedFlavorException, IOException {

	if (flavor.equals(table_selection_data_flavor)) {
	    return tsd;
	}
	else {
	    throw new UnsupportedFlavorException(flavor);
	}
    }
}