package koropeta.gui.metadataeditor;
import koropeta.*;
import koropeta.gui.*;
import koropeta.core.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class MetadataPanel extends JPanel {
    ShellInformationFrame frame;

    public MetadataPanel(ShellInformationFrame info_frame) {
	this.frame = info_frame;

	final String[][] fields = new String[][] {
	    new String[] {
		"name", // key
		GT.tr("name of the shell")}, // tooltip
	    
	    new String[] {
		"id",
		GT.tr("an ascii string that doesn't collide with other shell")},
	    
	    new String[] {
		"craftman",
		GT.tr("name of the auther of the shell in ascii string")},

	    new String[] {
		"craftmanw",
		GT.tr("name of the auther of the shell")},

	    new String[] {
		"craftmanurl",
		GT.tr(
		    /* ommitable: adj. can be ommited */
		    "URL of the shell (ommitable)")},

	    new String[] {
		"sakura.name",
		GT.tr("name of \\h to override the default (ommitable)")},

	    new String[] {
		"kero.name",
		GT.tr("name of \\u to override the default (ommitable)")},
	};

	SpringLayout sl = new SpringLayout();
	setLayout(sl);

	for (int i = 0; i < fields.length; i++) {
	    JLabel label = new JLabel(fields[i][0], SwingConstants.TRAILING);
	    add(label);

	    final Description descript_txt = frame.shell().modifiable_description();
	    final String key = fields[i][0];
	    String default_value = (String)descript_txt.get(key);
	    
	    final JTextField field = new JTextField(default_value == null ? "" : default_value);
	    field.setMaximumSize(
		new Dimension(
		    400,
		    field.getPreferredSize().height));
	    field.setPreferredSize(
		field.getMaximumSize());
	    field.setMinimumSize(
		field.getMaximumSize());
	    field.setToolTipText(fields[i][1]);
	    field.getDocument().addDocumentListener(
		new DocumentListener() {
		    public void insertUpdate(DocumentEvent e) {updated();}
		    public void removeUpdate(DocumentEvent e) {updated();}
		    public void changedUpdate(DocumentEvent e) {updated();}

		    private void updated() {
			if (field.getText().length() == 0) {
			    descript_txt.remove(key);
			}
			else {
			    descript_txt.put(key, field.getText());
			}
			descript_txt.dirty(true);

			if (key.equals("name")) {
			    // フレームの表題を直す必要がある。
			    frame.update_title();
			    frame.grid_frame.update_title();
			}
		    }
		});
	    add(field);
	}
	SpringUtils.makeCompactGrid(
	    this, fields.length, 2, 3, 3, 3, 3);
    }
}