package koropeta.gui.metadataeditor;
import koropeta.*;
import koropeta.gui.*;
import koropeta.core.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class ReadmePanel extends JPanel {
    ShellInformationFrame frame;

    public ReadmePanel(ShellInformationFrame info_frame) {
	this.frame = info_frame;

	final PlainText readme = frame.shell().readme();

	setLayout(new BorderLayout());

	JScrollPane scr = new JScrollPane(
	    JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
	    JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
	{
	    final JTextArea textarea = new JTextArea(readme.text());
	    textarea.getDocument().addDocumentListener(
		new DocumentListener() {
		    public void insertUpdate(DocumentEvent e) {updated();}
		    public void removeUpdate(DocumentEvent e) {updated();}
		    public void changedUpdate(DocumentEvent e) {updated();}

		    private void updated() {
			readme.text(textarea.getText());
			readme.dirty(true);
		    }
		});
	    scr.setViewportView(textarea);
	}
	add(scr, BorderLayout.CENTER);
    }
}