package koropeta.gui.metadataeditor;
import koropeta.*;
import koropeta.gui.*;
import koropeta.core.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

public class ShellInformationFrame extends JFrame {
    SurfaceGridFrame grid_frame;
    Shell shell;

    JTabbedPane tab;
    MetadataPanel metadata_panel;
    
    public ShellInformationFrame(SurfaceGridFrame grid_frame) {
	super(
	    GT.tr(
		/* {0}: name of shell */
		"{0} : Shell Information",
		grid_frame.get_shell_name()));
	
	this.grid_frame = grid_frame;
	this.shell = grid_frame.shell();

	getContentPane().setLayout(new BorderLayout());

	tab = new JTabbedPane(JTabbedPane.TOP, JTabbedPane.WRAP_TAB_LAYOUT);
	tab.addTab(GT.tr("Metadata"), new MetadataPanel(this));
	tab.addTab(GT.tr("Readme"), new ReadmePanel(this));
	tab.addTab(GT.tr("Thumbnail"), new JPanel());
	tab.addTab(GT.tr("Appearance of Menu"), new JPanel());
	tab.addTab(GT.tr("Positioning of Balloon"), new JPanel());
	tab.addTab(GT.tr("Installer Data"), new JPanel());

	getContentPane().add(tab, BorderLayout.CENTER);

	tab.setEnabledAt(2, false);
	tab.setEnabledAt(3, false);
	tab.setEnabledAt(4, false);
	tab.setEnabledAt(5, false);
	tab.setToolTipTextAt(
	    2, GT.tr("Not implemented yet"));
	tab.setToolTipTextAt(
	    3, GT.tr("Not implemented yet"));
	tab.setToolTipTextAt(
	    4, GT.tr("Not implemented yet"));
	tab.setToolTipTextAt(
	    5, GT.tr("Not implemented yet"));

	pack();
	setVisible(true);
    }

    public Shell shell() {
	return shell;
    }

    public SurfaceGridFrame grid_frame() {
	return grid_frame;
    }

    public void update_title() {
	setTitle(
	    GT.tr(
		/* {0}: name of shell */
		"{0} : Shell Information",
		grid_frame.get_shell_name()));
    }
}
