package koropeta.gui;
import koropeta.*;
import koropeta.gui.*;
import koropeta.core.*;
import java.util.*;
import java.net.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

public class AboutFrame extends JFrame {
    private static AboutFrame _shared = null;

    public static void display() {
	if (_shared == null) {
	    _shared = new AboutFrame();
	}
	_shared.setVisible(true);
	_shared.toFront();
    }

    protected AboutFrame() {
	super(GT.tr("About Koropeta..."));

	getContentPane().setLayout(new BorderLayout(1, 1));

	final JScrollPane scr = new JScrollPane(
	    JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
	    JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
	{
	    URL pd_icon = this.getClass().getResource("publicdomain.png");

	    String html =
		"<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01//EN\">"+
		"<html>"+
		"  <head>"+
		"    <meta http-equiv=\"Content-Style-Type\" content=\"text/css\">"+
		"    <title>About Koropeta...</title>"+
		"    <style>"+
		"      body {"+
		"          font-family: sans-serif;"+
		"          margin: 0;"+
		"          padding: 5px;"+
		"      }"+
		"      h1 {"+
		"          color: #444444;"+
		"          font-size: 130%;"+
		"          font-weight: bold;"+
		"          margin: 0;"+
		"          padding: 0;"+
		"      }"+
		"      h2 {"+
		"          color: #444444;"+
		"          font-size: 115%;"+
		"          font-weight: bold;"+
		"          margin: 15px 0 5px 0;"+
		"          padding: 0;"+
		"      }"+
		"      p {"+
		"          margin: 0 0;"+
		"          padding: 0;"+
		"      }"+
		"    </style>"+
		"  </head>"+
		"  <body>"+
		"    <h1>"+GT.tr(
		    /* Koropeta #VERSION */
		    "Koropeta #{0,number}", Main.VERSION)+"</h1>"+
		"    <h2>"+GT.tr("License")+"</h2>"+
		"    <p>"+
		"      <img src=\""+pd_icon+"\">"+
		"      "+GT.tr("This software is in the public domain.")+"<br>"+
		"      "+GT.tr("It may be freely reproduced, distributed, transmitted, used, modified, "+
			       "built upon, or otherwise exploited by anyone for any purpose, commercial "+
			       "or non-commercial, and in any way, including by methods that have not yet "+
			       "been invented or conceived.")+
		"    </p>"+
		"    <p>"+
		"      "+GT.tr("For more details, please read the following page:")+"<br>"+
		"      <a href=\"http://creativecommons.org/licenses/publicdomain/\">"+
		"        http://creativecommons.org/licenses/publicdomain/"+
		"      </a>"+
		"    </p>"+
		"    <h2>"+GT.tr("Creative Commons RDF")+"</h2>"+
		"    <pre>"+
		"&lt;rdf:RDF xmlns=&quot;http://web.resource.org/cc/&quot;\n"+
		"         xmlns:dc=&quot;http://purl.org/dc/elements/1.1/&quot;\n"+
		"         xmlns:rdf=&quot;http://www.w3.org/1999/02/22-rdf-syntax-ns#&quot;&gt;\n"+
		"   &lt;Work rdf:about=&quot;http://ccm.sherry.jp/koropeta/&quot;&gt;\n"+
		"      &lt;dc:title&gt;Koropeta&lt;/dc:title&gt;\n"+
		"      &lt;dc:rights&gt;&lt;Agent&gt;\n"+
		"         &lt;dc:title&gt;phonohawk&lt;/dc:title&gt;\n"+
		"      &lt;/Agent&gt;&lt;/dc:rights&gt;\n"+
		"      &lt;license rdf:resource=&quot;http://web.resource.org/cc/PublicDomain&quot; /&gt;\n"+
		"   &lt;/Work&gt;\n"+
		"   &lt;License rdf:about=&quot;http://web.resource.org/cc/PublicDomain&quot;&gt;\n"+
		"      &lt;permits rdf:resource=&quot;http://web.resource.org/cc/Reproduction&quot; /&gt;\n"+
		"      &lt;permits rdf:resource=&quot;http://web.resource.org/cc/Distribution&quot; /&gt;\n"+
		"      &lt;permits rdf:resource=&quot;http://web.resource.org/cc/DerivativeWorks&quot; /&gt;\n"+
		"   &lt;/License&gt;\n"+
		"&lt;/rdf:RDF&gt;"+
		"    </pre>"+
		"  </body>"+
		"</html>";
	    
	    JEditorPane editor = new JEditorPane("text/html", html);
	    editor.setEditable(false);
	    editor.setPreferredSize(
		new Dimension(650, 300));

	    scr.getViewport().setView(editor);

	    // 直接これをやっても效き目が無い。
	    SwingUtilities.invokeLater(
		new Runnable() {
		    public void run() {
			scr.getVerticalScrollBar().setValue(0);
		    }
		});
	}
	getContentPane().add(scr, BorderLayout.CENTER);

	JPanel pnl_button = new JPanel();
	{
	    pnl_button.setLayout(
		new FlowLayout(FlowLayout.TRAILING, 1, 1));

	    JButton close = new JButton(GT.tr("Close"));
	    close.addActionListener(
		new ActionListener() {
		    public void actionPerformed(ActionEvent ev) {
			setVisible(false);
		    }
		});
	    pnl_button.add(close);
	}
	getContentPane().add(pnl_button, BorderLayout.SOUTH);

	pack();
    }
}